<?php
/**
 * aac functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package aac
 */

if ( ! defined( '_S_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( '_S_VERSION', '1.0.0' );
}

/**
 * Sets up theme defaults and registers support for various WordPress features.
 *
 * Note that this function is hooked into the after_setup_theme hook, which
 * runs before the init hook. The init hook is too late for some features, such
 * as indicating support for post thumbnails.
 */
function aac_setup() {
	/*
		* Make theme available for translation.
		* Translations can be filed in the /languages/ directory.
		* If you're building a theme based on aac, use a find and replace
		* to change 'aac' to the name of your theme in all the template files.
		*/
	load_theme_textdomain( 'aac', get_template_directory() . '/languages' );

	// Add default posts and comments RSS feed links to head.
	add_theme_support( 'automatic-feed-links' );

	/*
		* Let WordPress manage the document title.
		* By adding theme support, we declare that this theme does not use a
		* hard-coded <title> tag in the document head, and expect WordPress to
		* provide it for us.
		*/
	add_theme_support( 'title-tag' );

	/*
		* Enable support for Post Thumbnails on posts and pages.
		*
		* @link https://developer.wordpress.org/themes/functionality/featured-images-post-thumbnails/
		*/
	add_theme_support( 'post-thumbnails' );

	// This theme uses wp_nav_menu() in one location.
	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'aac' ),
		)
	);

	/*
		* Switch default core markup for search form, comment form, and comments
		* to output valid HTML5.
		*/
	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	// Set up the WordPress core custom background feature.
	add_theme_support(
		'custom-background',
		apply_filters(
			'aac_custom_background_args',
			array(
				'default-color' => 'ffffff',
				'default-image' => '',
			)
		)
	);

	// Add theme support for selective refresh for widgets.
	add_theme_support( 'customize-selective-refresh-widgets' );

	/**
	 * Add support for core custom logo.
	 *
	 * @link https://codex.wordpress.org/Theme_Logo
	 */
	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);
}
add_action( 'after_setup_theme', 'aac_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $content_width
 */
function aac_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'aac_content_width', 640 );
}
add_action( 'after_setup_theme', 'aac_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function aac_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'aac' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'aac' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'aac_widgets_init' );

/**
 * Enqueue scripts and styles.
 */
function aac_scripts() {
	wp_enqueue_style( 'aac-style', get_stylesheet_uri(), array(), _S_VERSION );
	wp_style_add_data( 'aac-style', 'rtl', 'replace' );

	wp_enqueue_script( 'aac-navigation', get_template_directory_uri() . '/js/navigation.js', array(), _S_VERSION, true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}
}
add_action( 'wp_enqueue_scripts', 'aac_scripts' );

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/inc/customizer.php';

/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/inc/jetpack.php';
}

function theme_enqueue_google_fonts() {
    echo '<link rel="preconnect" href="https://fonts.googleapis.com">' . "\n";
    echo '<link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>' . "\n";
}
add_action('wp_head', 'theme_enqueue_google_fonts', 5);

function theme_enqueue_styles() {
    wp_enqueue_style(
        'google-fonts-outfit',
        'https://fonts.googleapis.com/css2?family=Outfit:wght@100..900&display=swap',
        array(),
        null
    );
}
add_action('wp_enqueue_scripts', 'theme_enqueue_styles');

function acc_enqueue_assets() {
    wp_enqueue_style( 'acc-style', get_stylesheet_uri() );

    wp_enqueue_style(
        'acc-custom',
        get_template_directory_uri() . '/css/custom.css',
        array('acc-style'),
    	filemtime( get_template_directory() . '/css/custom.css' )
    );
}
add_action( 'wp_enqueue_scripts', 'acc_enqueue_assets' );
function acc_enqueue_scripts() {
    wp_enqueue_script(
        'acc-custom',
        get_template_directory_uri() . '/js/custom.js',
        array('jquery'),
        filemtime( get_template_directory() . '/js/custom.js' ),
        true
    );
}
add_action( 'wp_enqueue_scripts', 'acc_enqueue_scripts' );


add_action('wp_enqueue_scripts', function() {
    wp_enqueue_script(
        'aac-loadmore-blog',
        get_template_directory_uri() . '/js/blog-loadmore.js',
        ['jquery'],
        null,
        true
    );
    wp_enqueue_script(
        'aac-loadmore-podcasts',
        get_template_directory_uri() . '/js/podcasts-loadmore.js',
        ['jquery'],
        null,
        true
    );

    wp_localize_script('aac-loadmore-blog', 'aac_loadmore_params', [
        'ajax_url' => admin_url('admin-ajax.php'),
        'cat'      => isset($_GET['cat']) ? intval($_GET['cat']) : 0,
    ]);
});

add_action('wp_ajax_load_more_posts', 'aac_load_more_posts');
add_action('wp_ajax_nopriv_load_more_posts', 'aac_load_more_posts');

add_action('wp_ajax_load_more_podcasts', 'aac_load_more_podcasts');
add_action('wp_ajax_nopriv_load_more_podcasts', 'aac_load_more_podcasts');

function aac_load_more_posts() {
    $paged = isset($_POST['paged']) ? intval($_POST['paged']) + 1 : 2;

    $args = [
        'post_type'      => 'post',
        'posts_per_page' => 9,
        'paged'          => $paged,
        'orderby'        => 'date',
        'order'          => 'DESC',
    ];
	$cat = isset($_POST['cat']) ? intval($_POST['cat']) : 0;

	if ($cat) {
		$args['cat'] = $cat;
	}

    $query = new WP_Query($args);

    if ($query->have_posts()) :
        ob_start();
        while ($query->have_posts()) : $query->the_post();
            get_template_part('inc/template-article-card', null, [
                'image' => get_the_post_thumbnail_url(get_the_ID(), 'medium_large'),
                'title' => get_the_title(),
                'link'  => get_the_permalink(),
				'category' => get_the_category()
            ]);
        endwhile;

        wp_send_json_success([
            'html'  => ob_get_clean(),
            'paged' => $paged,
            'max'   => $query->max_num_pages,
        ]);
    else :
        wp_send_json_error('Brak więcej postów.');
    endif;

    wp_die();
}

function aac_load_more_podcasts() {
    $paged = isset($_POST['paged']) ? intval($_POST['paged']) + 1 : 2;

    $args = [
        'post_type'      => 'podcasty',
    	'posts_per_page' => 6,
        'paged'          => $paged,
    	'orderby'        => 'date',
    	'order'          => 'DESC',
    	'post_status'    => 'publish',
    ];

    $query = new WP_Query($args);

    if ($query->have_posts()) :
        ob_start();
        while ($query->have_posts()) : $query->the_post();
            get_template_part('inc/template-podcast-card', null, [
				'image' => get_the_post_thumbnail_url(get_the_ID(), 'medium_large'),
				'title' => get_the_title(),
				'link'  => get_the_permalink(),
				'acf'   => get_field('time')
            ]);
        endwhile;

        wp_send_json_success([
            'html'  => ob_get_clean(),
            'paged' => $paged,
            'max'   => $query->max_num_pages,
        ]);
    else :
        wp_send_json_error('Brak więcej podcastów.');
    endif;

    wp_die();
}

add_action('init', function() {
    register_block_type( get_template_directory() . '/blocks/alert-info' );
});

// function fix_single_letter_space($text) {
//     $pattern = '/\b([A-Za-zĄąĆćĘęŁłŃńÓóŚśŹźŻż])\s+(?=\S)/u';
//     $replacement = '$1&nbsp;';
//     return preg_replace($pattern, $replacement, $text);
// }
// add_filter('the_content', 'fix_single_letter_space');

function fix_single_letter_space_safe($html) {
    return preg_replace_callback(
        '/>([^<]+)</u',
        function ($matches) {
            $text = $matches[1];
            $pattern = '/\b([A-Za-zĄąĆćĘęŁłŃńÓóŚśŹźŻż])\s+(?=\S)/u';
            $replacement = '$1&nbsp;';
            $text = preg_replace($pattern, $replacement, $text);
            return '>' . $text . '<';
        },
        $html
    );
}

function fix_single_letter_output_buffer_start() {
    ob_start('fix_single_letter_space_safe');
}
add_action('template_redirect', 'fix_single_letter_output_buffer_start');

function enable_dashicons_for_frontend() {
    wp_enqueue_style('dashicons');
}
add_action('wp_enqueue_scripts', 'enable_dashicons_for_frontend');
